    .386p

;*******************************************************************
;                I N C L U D E S
;*******************************************************************

    include vmm.inc
    include debug.inc

;===================================================================
;        V I R T U A L   D E V I C E   D E C L A R A T I O N
;===================================================================
DECLARE_VIRTUAL_DEVICE    _DEVICEN, 1, 0, _ControlProc, \
                            UNDEFINED_DEVICE_ID, \
                            UNDEFINED_INIT_ORDER 
public _DEVICEN_DDB

VxD_LOCKED_CODE_SEG

;===================================================================
;
;   PROCEDURE: ControlProc
;
;   DESCRIPTION:
;    Device control procedure for the SKELETON VxD
;
;   ENTRY:
;    EAX = Control call ID
;
;   EXIT:
;    If carry clear then
;        Successful
;    else
;        Control call failed
;
;   USES:
;    EAX, EBX, ECX, EDX, ESI, EDI, Flags
;
;===================================================================

; referenced by C code, so need a leading underscore in name
BeginProc _ControlProc

    mov eax, CR0
    Control_Dispatch SYS_VM_INIT, \
                    _OnSysVmInit, cCall, <ebx>
    Control_Dispatch SYS_VM_TERMINATE, \
                    _OnSysVmTerminate, cCall, <ebx>
    Control_Dispatch W32_DEVICEIOCONTROL, \
                    _OnW32Deviceiocontrol, cCall, <-1, esi>
    clc
    ret

EndProc _ControlProc

BeginProc _Device1ControlProc

    Control_Dispatch W32_DEVICEIOCONTROL, \
                    _OnW32Deviceiocontrol, cCall, <0, esi>
    clc
    ret

EndProc _Device1ControlProc

BeginProc _Device2ControlProc

    Control_Dispatch W32_DEVICEIOCONTROL, \
                    _OnW32Deviceiocontrol, cCall, <1, esi>
    clc
    ret

EndProc _Device2ControlProc

VxD_LOCKED_CODE_ENDS

    END
